﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;
using Ors.Rams.Workstation.Common.InfragisticsIntegration;

namespace PaginatedUltraWinGrid
{
    public partial class Form1 : Form
    {

        DataProvider dataProvider = new DataProvider();


        public Form1()
        {
            this.dataProvider.GenerateData();

            InitializeComponent();
            this.ultraGrid1.DisplayLayout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            this.ultraGrid1.DisplayLayout.Override.RowSelectorNumberStyle = Infragistics.Win.UltraWinGrid.RowSelectorNumberStyle.RowIndex;

            this.ultraGrid1.DisplayLayout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            this.ultraGrid1.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortMulti;

            this.ultraGrid1.ChunkRequesting += new EventHandler<ChunkRequestEventArgs>(ultraGrid1_ChunkRequesting);
            this.ultraGrid1.FilterValuesRequesting += new EventHandler<FilterValuesEventArgs>(ultraGrid1_FilterValuesRequesting);

            this.dataProvider.DataProviding += new EventHandler<DataEventArgs>(dataProvider_DataProviding);
        }

        void ultraGrid1_FilterValuesRequesting(object sender, FilterValuesEventArgs e)
        {
            UltraGridPaginated grid = sender as UltraGridPaginated;
            if (grid != null) {
                foreach (string key in e.ColumnsKeys) {
                    grid.SetFilterValues ( 
                        key, 
                        this.dataProvider.DistinctValues(key, grid.FilterAdapter.TranslateFilter<DataTable>(e.Filter).ToString())
                    );
                }
            }
        }

        void dataProvider_DataProviding(object sender, DataEventArgs e)
        {
            this.ultraGrid1.AddChunk (e.Data, this.dataProvider.RowsCount);
            try {
                this.ultraLabel1.Text = "Rows: " + this.ultraGrid1.Rows.Count.ToString();
                this.ultraLabel2.Text = "Chunk: " + this.ultraGrid1.ChunkSize.ToString();
            } catch { }
        }

        void ultraGrid1_ChunkRequesting(object sender, ChunkRequestEventArgs e)
        {
            UltraGridPaginated grid = sender as UltraGridPaginated;
            if (grid !=null){
                this.dataProvider.RequestUsers( grid.FilterAdapter.TranslateFilter<DataTable>(e.Filter).ToString()
                                                , grid.SortAdapter.TranslateSort<DataTable>(e.Sort).ToString()
                                                , e.LastIndex, e.ChunkSize);
            }
        }




        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            //this.ultraGrid1.ChunkSize = 100;
            this.dataProvider.RequestUsers("", "", 0, this.ultraGrid1.ChunkSize);
        }

        


    }
}
